import java.awt.event.*;
import java.awt.image.*;
import java.awt.color.*;
import java.awt.geom.*;
import java.awt.*;
import java.io.File;
import java.util.Vector;
import java.awt.image.BufferedImage;
import javax.swing.*;
import javax.imageio.ImageIO;


class Shape implements Cloneable{
		int x1,y1,x2,y2;
		boolean filled,rounded;
		boolean dashed;
		float strokesize;
		String type;
		Color col;
		String ftyp;
		int fsiz;
		Color g1,g2;
		boolean gra;
		String buf;
		AffineTransform affine = new AffineTransform();
		String im;
		int transp;
        
        public void setToSame(Shape x)
		{
			x.x1=x1 ;x.y1=y1; x.x2=x2; x.y2=y2;
			x.filled=filled; x.rounded=rounded;
			x.dashed=dashed;
			x.strokesize=strokesize;
			x.type=type;
			x.col=col;
			x.ftyp=ftyp;
			x.fsiz=fsiz;
			x.g1=g1; x.g2=g2;
			x.gra=gra;
			x.buf=buf;
			x.affine = new AffineTransform(affine);
			x.im=im;
			x.transp=transp;
		}
        		   
	    public Shape(int ax,int ay, int ax2, int ay2, String typ,String img)
	    {
	    	x1=ax;
	    	y1=ay;
	    	x2=ax2;
	    	y2=ay2;
	    	type=typ;
	    	im=img;
	    	
	    }
	    public Shape(int a1,int b1,int a2,int b2)
		{
			x1=a1;
			y1=b1;
			x2=a2;
			y2=b2;
	    }
		
		public Shape(int a1,int b1)
		{
			x1=a1;
			y1=b1;
		}
		
		public Shape(){;}
		
	    public Shape(int a1,int b1,int a2,int b2,
		float astrokesize,String atype, Color acol)
		{
			x1=a1;
			y1=b1;
			x2=a2;
			y2=b2;
	      	
			strokesize = astrokesize;
			type = atype;
			col = acol;
		}
		
		public Shape(int a1,int b1,int a2,int b2,boolean afilled,boolean arounded,
		boolean adashed,float astrokesize,String atype, Color acol)
		{
			x1=a1;
			y1=b1;
			x2=a2;
			y2=b2;
	      	filled =afilled;
	      	rounded=arounded;
		 	dashed = adashed;
			strokesize = astrokesize;
			type = atype;
			col = acol;
		
		}
		
		public Shape(int a1,int b1,String pbuf,
		int fsize,String ftype,String atype, Color acol)
		{
			x1=a1;
			y1=b1;
		    type = atype;
			col = acol;
			buf = pbuf;
			fsiz = fsize;
			ftyp = ftype;
		}
		
		
}


public class DrawCanvas extends Panel implements MouseListener,
MouseMotionListener, KeyListener, ActionListener{

    public static final int LINES = 0;
    public static final int POINTS = 1;
    public static final int RECT = 2;
    public static final int ELLIPSE = 3;
    public static final int ARC = 4;
    public static final int TEXT = 5;
	public static final int IMAGE = 6;
	
	int ImOp=0;
	int NEG=1;
	int RESC=2;
	int BLUR=3;
	int SH=4;
	
	AlphaComposite init	;
    int transparent=0;
    int mode = LINES , istr=0;
    boolean   motion = false,   round = false ; 
    boolean   fill, clear, gra=false, back=false ;
    boolean exten=false,up=false,down=false;
    boolean copy=true; 
    boolean showImg = false;
    boolean clock, hor;
    boolean scaleplus=true;
    Vector obj2D = new Vector();
    
    StringBuffer tbuf = new StringBuffer();
    String picImg = "jicon.gif";
    String font = "Times New Roman";
    String trans = new String("None");
    Shape r = new Shape(); 
    Shape p = new Shape();
    Shape pdash = new Shape();
    int fontsiz=8;
      
    float strokew=1; // stroke width
    String strokestr = "plain" ; //dashed stroke string etc
    Color grad1 = Color.white, grad2 = Color.black; //gradient colors
    int transindex; //transform index
      
    BufferedImage OSC; // The off-screen canvas for Double Buffering
    BufferedImage bimg;
    int widthOfOSC, heightOfOSC;
    
    AffineTransform at = new AffineTransform();
    AffineTransform prevTrans = new AffineTransform();
    
    int x,y; 
    int xx,yy;
    int x1,y1;
    int x2,y2;
    int dx,dy;
    int xdiff,ydiff;
    int index;
    int keyx=10,keyy=10;
    int imposx=0,imposy=0;
    char keystroke;
    
    String imgformat="jpg";
    String types = new String();
    String buf = new String();
    StringBuffer buf2;
    
    BasicStroke stroke = new BasicStroke(2.0f);
    
    float dash1[] = {10.0f};
    BasicStroke dashed = new BasicStroke(1.0f,BasicStroke.CAP_ROUND, 
                                              BasicStroke.JOIN_BEVEL, 
                                              10.0f, dash1, 0.0f);
    
    public void sstrokew(float val)
    {
    	stroke = new BasicStroke(val);
    	strokew = val;
    }
    
   
    PopupMenu popup = new PopupMenu();
    CheckboxMenuItem cmi = new CheckboxMenuItem("Move",false);
    
   	public void setDrawMode(int mode) {
        switch (mode) {
          case LINES:
          case RECT:
          case POINTS:
          case ELLIPSE:
          case ARC:
          case TEXT:
          case IMAGE: 
            this.mode = mode;
            break;
          default:
            this.mode = 1000;
        }
    }

    public void setFillMode2(boolean fill2) {
        fill = fill2;
    }

    public void setClear(boolean clr) {
        clear = clr;
    }
    

    public void showSetImg()
    {
    	showImg=true;
    	System.out.println(picImg);
    }
    
    public void encodeImg(String imgfile)
    {
    
    	File ifile=new File(imgfile+"."+imgformat);
    	System.out.println("---> "+imgfile);
    	
       	try
    	{
    		if(ImOp == 0)
    			ImageIO.write(OSC,imgformat,ifile);
    		else
    			ImageIO.write(bimg,imgformat,ifile);
    	}
    	catch(Exception e)
    	{
    		System.out.println(e);
    	}
    	    	
    }
    
    
	
    // MOUSE EVENT METHODS FOLLOW    
    public void mouseDragged(MouseEvent e) {

        e.consume();
        //if(e.isButton2Down()) return;
        x = e.getX();
        y = e.getY();
        
        if(motion==true)
        {
	        if(exten==true && up==true)
	        {
	        	((Shape)obj2D.elementAt(index)).x1 = x;
	            ((Shape)obj2D.elementAt(index)).y1 = y;
	            repaint();
	            return;
	        }
	        
	        if(exten==true && down==true)
	        {
	            ((Shape)obj2D.elementAt(index)).x2 = x;
	            ((Shape)obj2D.elementAt(index)).y2 = y;
	            repaint();
	            return;
	        }
            //int x,y;
            
            if(obj2D.size()>=0 && index<obj2D.size())
            {
                //obj2D.remove(obj2D.size()-1);
                //obj2D.addElement(new Rectangle( x-dx, y-dy, x-dx+(r.width-r.x), y-dy+(r.height-r.y) ));
                
                ((Shape)obj2D.elementAt(index)).x1 = x-dx;
                ((Shape)obj2D.elementAt(index)).y1 = y-dy;
                ((Shape)obj2D.elementAt(index)).x2 = x-dx+(xdiff);
                ((Shape)obj2D.elementAt(index)).y2 = y-dy+(ydiff);
                
      	        repaint();
            }
            repaint();
            return;
        }

        switch (mode) {
            case ELLIPSE:
            case LINES:
            case RECT:
            case ARC:
                x2 = e.getX();
                y2 = e.getY();
                break;

            case POINTS:
            default:
                obj2D.addElement(new Shape(x1, y1, e.getX(), e.getY(),strokew,"Line",getForeground()));
                x1 = e.getX();
                y1 = e.getY();
                x2=-1;
                break;
        }
        if(mode!=TEXT)
        	repaint();
    }

    public void mouseMoved(MouseEvent e) {
         xx = e.getX();
         yy = e.getY();
         
         //repaint();

    }

    public void mousePressed(MouseEvent e) {

        //int x,y;
        e.consume();
        //if(e.isButton2Down()) return;
        
        x = e.getX();
        y = e.getY();
        
        index = findClicked(x,y);
               
        if(motion==true || trans.equals("Transform"))
        {
            x = e.getX();
            y = e.getY();
            
            index = findClicked(x,y);
            if(index==-1){repaint(); return;}
            
            setForeground(((Shape)obj2D.elementAt(index)).col);
            
            
            if(trans.equals("Rotate"))
            	setTrans();
            if(trans.equals("Shear"))
            	setTrans();
            if(trans.equals("Scale"))
            	setTrans();
            
            	extend(x,y);
            if(exten==true) mouseDragged(e);
            
            System.out.println(" Index: "+index);
            if (e.isPopupTrigger()) {            // If this is a pop-up menu event that
                popup.show(this,x,y);
            }

            dx = x-(r.x1);
            dy = y-(r.y1);
            xdiff = (Math.abs(r.x2-r.x1));
            ydiff = (Math.abs(r.y2-r.y1));
            
            xx=r.x1;
            yy=r.y1;
                       
            if(obj2D.size()>0 && index<obj2D.size())
            {
                
            
            }
            repaint();
            return;
        }

        if (e.isPopupTrigger()) {    // If this is a pop-up menu event that
            popup.show(this,x,y);
            index = findClicked(x,y);
            if(index==-1){repaint(); return;}
            
        }


        switch (mode) {
        	
            case ELLIPSE:
            case LINES:
            case RECT:
            case ARC:
                x1 = e.getX();
                y1 = e.getY();
                x2 = -1;
                break;
            case POINTS:
            default:
               
                obj2D.addElement(new Shape(e.getX(), e.getY(), e.getX(), e.getY(), strokew,"Line",getForeground()));
                x1 = e.getX();
                y1 = e.getY();
                if(mode!=TEXT)
                	repaint();
                break;
        }
    }

    public void mouseReleased(MouseEvent e) {

        int rp = obj2D.size();
        x = e.getX();
        y = e.getY();
        if(e.getButton() == 0) return;

        if(motion==true)
        {
            if(exten==true && up==true)
	        {
	        	((Shape)obj2D.elementAt(index)).x1 = x;
	            ((Shape)obj2D.elementAt(index)).y1 = y;
	            repaint();
	            return;
	        }
	        
	        if(exten==true && down==true)
	        {
	            ((Shape)obj2D.elementAt(index)).x2 = x;
	            ((Shape)obj2D.elementAt(index)).y2 = y;
	            repaint();
	            return;
	        }
            x = e.getX();
            y = e.getY();

            if (e.isPopupTrigger()) {            // If this is a pop-up menu event that
                popup.show(this,x,y);
            }

            if(obj2D.size()>=0 && index<obj2D.size())
            {
                
                ((Shape)obj2D.elementAt(index)).x1 = x-dx;
                ((Shape)obj2D.elementAt(index)).y1 = y-dy;
                ((Shape)obj2D.elementAt(index)).x2 = x-dx+(xdiff);
                ((Shape)obj2D.elementAt(index)).y2 = y-dy+(ydiff);
                
                repaint();
            }
            repaint();
            return;
        }

        if (e.isPopupTrigger()) {            // If this is a pop-up menu event that
            popup.show(this,x,y);
        }

        switch (mode) {

            case TEXT:
        		keyx = e.getX();
        		keyy = e.getY();
        		tbuf=new StringBuffer();
        		//System.out.println("Text Mode Set");
        		break;
        		
            case ELLIPSE:
                
                //int ep = obj2D.size();
                //checkSwap();
                if(!(x1==e.getX() && y1==e.getY()));
                	obj2D.addElement(new Shape(x1, y1, e.getX(), e.getY(),false,false,false,strokew,"Ellipse",getForeground()));
               
                if(round==true)
                {
                    ((Shape)obj2D.elementAt(rp-1)).rounded = true;
                    
                }
                if(fill==true)
                {
                    ((Shape)obj2D.elementAt(obj2D.size()-1)).filled = true;
               
	                if(gra==true)
	                {
	                	((Shape)obj2D.elementAt(obj2D.size()-1)).gra = true;
	                	((Shape)obj2D.elementAt(obj2D.size()-1)).g1 = grad1;
	                	((Shape)obj2D.elementAt(obj2D.size()-1)).g2 = grad2;
	                }
            	}
               
                break;
                
            case LINES:
               
               
	            if(!(x1==e.getX() && y1==e.getY()));
	            	obj2D.addElement(new Shape(x1, y1, e.getX(), e.getY(),false,false,false,strokew,"Line",getForeground()));
                if(strokestr.equals("dashed"))
		        {
		            ((Shape)obj2D.elementAt(obj2D.size()-1)).dashed = true;
		        }
		        
                            
                break;

            case RECT:
          
                x2=e.getX();
                y2=e.getY();
                checkSwap();
             
                obj2D.addElement(new Shape(x1, y1, e.getX(), e.getY(),false,false,false,strokew,"Rectangle",getForeground()));
                
                if(round==true)
                {
                    ((Shape)obj2D.elementAt(obj2D.size()-1)).rounded = true;
                    
                }
                if(fill==true)
                {
                    ((Shape)obj2D.elementAt(obj2D.size()-1)).filled = true;
               
	                if(gra==true)
	                {
	                	((Shape)obj2D.elementAt(obj2D.size()-1)).gra = true;
	                	((Shape)obj2D.elementAt(obj2D.size()-1)).g1 = grad1;
	                	((Shape)obj2D.elementAt(obj2D.size()-1)).g2 = grad2;
	                }
            	}
                            
               
                break;

            case ARC:
                
                obj2D.addElement(new Shape(x1, y1, e.getX(), e.getY(),false,false,false,strokew,"Arc",getForeground()));
                if(fill==true)
                {
                    ((Shape)obj2D.elementAt(obj2D.size()-1)).filled = true;
               
	                if(gra==true)
	                {
	                	((Shape)obj2D.elementAt(obj2D.size()-1)).gra = true;
	                	((Shape)obj2D.elementAt(obj2D.size()-1)).g1 = grad1;
	                	((Shape)obj2D.elementAt(obj2D.size()-1)).g2 = grad2;
	                }
            	}
               
                break;
                
            case POINTS:
                break; 
            case IMAGE:
            	imposx = e.getX();
            	imposy = e.getY();
            	System.out.println("-->"+imposx+"  "+imposy);
            	setDrawMode(1000);

            default:
                break;
        }
      
        if(strokestr.equals("dashed"))
        {
            ((Shape)obj2D.elementAt(obj2D.size()-1)).dashed = true;
        }
        if(transparent==1)
        {
        	((Shape)obj2D.elementAt(obj2D.size()-1)).transp = 1;
        }
        if(mode!=TEXT)
        	repaint();
    }

    public void mouseEntered(MouseEvent e) {

         xx = e.getX();
         yy = e.getY();
                  
         //repaint();
        
    }

    public void mouseExited(MouseEvent e) {
         xx = e.getX();
         yy = e.getY();
         //repaint();
        
    }

    public void mouseClicked(MouseEvent e) {
         xx = e.getX();
         yy = e.getY();
         x = e.getX();
         y = e.getY();
         //index = findClicked(x,y);
         //extend(x,y);
         //repaint();
         
    }

    public void extend(int x,int y)
    {
    	
    	if(x>r.x1 && y>r.y1 && x<r.x1+10 && y<r.y1+10)
    	{
    		exten=true; up=true; down=false;
    	}
    	
    	else if(x>r.x2-10 && y>r.y2-10 && x<r.x2 && y<r.y2)
    	{
    		exten=true; down=true; up=false;
    	}
      	else
      	{
      		exten=up=down=false;
      	}
    
    }
    
    public void setTrans() {
    
		     
		((Shape)obj2D.elementAt(index)).affine.concatenate(at);
		
		if(trans.equals("Rotate")){
			
			((Shape)obj2D.elementAt(index)).affine.translate(r.x1,r.y1);
			if(clock==true)
			
				((Shape)obj2D.elementAt(index)).affine.rotate(Math.toRadians(5),(((Shape)obj2D.elementAt(index)).x2-((Shape)obj2D.elementAt(index)).x1)/2,(((Shape)obj2D.elementAt(index)).y2-((Shape)obj2D.elementAt(index)).y1)/2);
			else
				((Shape)obj2D.elementAt(index)).affine.rotate(Math.toRadians(-5),(((Shape)obj2D.elementAt(index)).x2-((Shape)obj2D.elementAt(index)).x1)/2,(((Shape)obj2D.elementAt(index)).y2-((Shape)obj2D.elementAt(index)).y1)/2);
			
			((Shape)obj2D.elementAt(index)).affine.translate(-r.x1,-r.y1);
		}	
		
		if(trans.equals("Scale")){
					
				System.out.println("Here");
				((Shape)obj2D.elementAt(index)).affine.translate(r.x1,r.y1);
				if(scaleplus==true)
					((Shape)obj2D.elementAt(index)).affine.scale(1.2,1.2);
				else
					((Shape)obj2D.elementAt(index)).affine.scale(0.8,0.8);
				((Shape)obj2D.elementAt(index)).affine.translate(-r.x1,-r.y1);
		}
					
		else if(trans.equals("Shear"))
		{
			if(hor==true)
			{
				((Shape)obj2D.elementAt(index)).affine.translate(r.x1,r.y1);
				
				if(clock==true)
					((Shape)obj2D.elementAt(index)).affine.shear(0.2, 0.0); 
				else
					((Shape)obj2D.elementAt(index)).affine.shear(-0.2, 0.0); 
					
				((Shape)obj2D.elementAt(index)).affine.translate(-r.x1,-r.y1);
			}
			else
			{
				((Shape)obj2D.elementAt(index)).affine.translate(r.x1,r.y1);
				
				if(clock==true)
					((Shape)obj2D.elementAt(index)).affine.shear(0.0, 0.2); 
				else
					((Shape)obj2D.elementAt(index)).affine.shear(0.0, -0.2);
					 
				((Shape)obj2D.elementAt(index)).affine.translate(-r.x1,-r.y1);	
			}
		}
		
		//((Shape)obj2D.elementAt(index)).affine.translate(-((Shape)obj2D.elementAt(index)).x1,-((Shape)obj2D.elementAt(index)).y1); 
		//((Shape)obj2D.elementAt(index)).affine.translate(-(((Shape)obj2D.elementAt(index)).x1), -(((Shape)obj2D.elementAt(index)).y1));

	}


    int findClicked(int x, int y) {

        for ( int i = obj2D.size() - 1; i >= 0; i-- ) {

            Shape s = (Shape)obj2D.elementAt(i);
            if ((x>(s.x1) && x<(s.x2)) && (y>(s.y1) && y<(s.y2)))
            {
               //setForeground(((Shape)obj2D.elementAt(i)).col);
               r=s;
               index=i;
               types = ((Shape)obj2D.elementAt(i)).type;
               return i;
            }
            else{ r=null; index = -1;}
        }
    
        //return obj2D.size();
        return -1;
    }

    
    //KEY EVENTS START
    public void keyPressed(KeyEvent ke)
    {
    	/*setDrawMode(TEXT);
    	keystroke = ke.getKeyChar();
      	System.out.println(keystroke);
      	repaint();*/
	}
	
	public void keyReleased(KeyEvent ke)
    {
    	/*keystroke = ke.getKeyChar();
    	System.out.println(keystroke);
    	repaint();*/
	}
	
	public void keyTyped(KeyEvent ke)
    {
       	if(ke.getKeyChar() == ke.VK_BACK_SPACE)
       	{
            	
            	System.out.println(tbuf.length());
            	back=true;
            	repaint();
        }
        else
        {
        		keystroke = ke.getKeyChar();    
    	    	repaint();
    	}
	}
	//KEY EVENTS END
	
	public static final float[] SHARPEN3x3_3 = {
	0.f, -1.f,  0.f,
	-1.f,  5.0f, -1.f,
	0.f, -1.f,  0.f};

	float[][] data = {
	{0.1f, 0.1f, 0.1f,    // low-pass filter
	0.1f, 0.2f, 0.1f,
	0.1f, 0.1f, 0.1f},
	SHARPEN3x3_3};
	
	
	private BufferedImage bi[];
	Image img;
	
    public void update(Graphics g) {

         if (OSC == null || widthOfOSC != getSize().width || heightOfOSC != getSize().height) {
             OSC = null;  
             OSC = (BufferedImage)createImage(getSize().width, getSize().height);
             widthOfOSC = getSize().width;
             heightOfOSC = getSize().height;
         }
          	 
         Graphics OSG = OSC.getGraphics();  // Graphics context for drawing to OSC.
                
         OSG.setColor(getBackground());
         OSG.fillRect(0, 0, widthOfOSC, heightOfOSC);
         OSG.setColor(getForeground());
         OSG.setFont(getFont());
                  
		 paint(OSG);   // Draw screen contents to OSC.  
		 
		//------------------------------------------------------
		int iw = OSC.getWidth(this);
		int ih = OSC.getHeight(this);
			
		Graphics2D g2 = (Graphics2D) g;
		        
		bimg = new BufferedImage(iw,ih,BufferedImage.TYPE_INT_RGB);
					
			
		if(ImOp !=0)
		{
		
			if(ImOp == NEG)
			{
				byte chlut[] = new byte[256]; 
		        for (int j=0;j<200 ;j++ )
		            chlut[j]=(byte)(256-j); 
		        ByteLookupTable blut=new ByteLookupTable(0,chlut); 
		        LookupOp lop = new LookupOp(blut, null); 
		        lop.filter(OSC,bimg);  
		    }
	        
	        if(ImOp == RESC) //Brighten
	        {
		        RescaleOp rop = new RescaleOp(1.1f,30.0f, null);
		        rop.filter(OSC,bimg);  
		       
	    	}
	        if(ImOp == BLUR)
	        {
	        	Kernel kernel = new Kernel(3,3,data[0]);
	        	ConvolveOp cop1 = new ConvolveOp(kernel,ConvolveOp.EDGE_NO_OP,null);
	        	cop1.filter(OSC,bimg);
	        }
	        if(ImOp == SH)
	        {
	        	Kernel kernel = new Kernel(3,3,data[1]);
	        	ConvolveOp cop2 = new ConvolveOp(kernel,ConvolveOp.EDGE_NO_OP, null);
	        	cop2.filter(OSC,bimg);
	        }
					 
	        g2.drawImage(bimg,0,0,this);         // Copy OSC to screen.
	        //ImOp=0;
	     }
	     else
	     	g2.drawImage(OSC,0,0,this);     
    }
    
  
    
    public Graphics2D createGraphics2D(int w, int h) {
        Graphics2D g2 = null;
        if (bimg == null || bimg.getWidth() != w || bimg.getHeight() != h) {
            bimg = (BufferedImage) createImage(w, h);
            //reset(w, h);
        } 
        g2 = bimg.createGraphics();
        g2.setBackground(getBackground());
        g2.clearRect(0, 0, w, h);
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                            RenderingHints.VALUE_ANTIALIAS_ON);
        return g2;
    }
    
    //  p a i n t  M E T H O D  H E R E 
    public void paint(Graphics g2) {   

        ((Graphics2D)g2).setRenderingHint
        (RenderingHints.KEY_ANTIALIASING,
        RenderingHints.VALUE_ANTIALIAS_ON);

		((Graphics2D)g2).setRenderingHint
        (RenderingHints.KEY_DITHERING,
        RenderingHints.VALUE_DITHER_ENABLE);

        Graphics2D g=(Graphics2D)g2;
        
        // Later Code
        //Dimension d = getSize();
        //Graphics2D g = createGraphics2D(d.width, d.height);
        
        if(clear == true){

            obj2D.removeAllElements();
            
            g.setPaint(this.getBackground());
            g.fill(new Rectangle2D.Double(0,0,1800,1800));

            x2 = -1;
            clear=false;
            
        }

        
        int np = obj2D.size();
        int OBJ=0;
        //g.setColor(getForeground());
        
        
        g.setComposite(init);
        for (int i=0; i < np; i++) {
        	
        	Shape pp = (Shape)obj2D.elementAt(i);
        	g.setColor(pp.col);
        	prevTrans = g.getTransform();
            g.transform(pp.affine);
            //g.rotate(1.0,(double)pp.x1,(double)pp.y1);
        	if(pp.transp == 1)
	        {
				AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER,0.5f);
	  	    	g.setComposite(ac);
	  		}
            if(pp.type.equals("Ellipse"))
            {OBJ=1;}
            else if((pp.type).equals("Rectangle"))
            {OBJ=2;}
            else if((pp.type).equals("Line"))
            {OBJ=4;}
			else if((pp.type).equals("Arc"))
            {OBJ=3;}
            else if((pp.type).equals("Text"))
            {OBJ=6;}
            else if((pp.type).equals("Image"))
            {OBJ=7;}
            
            switch(OBJ)
            {
                case 1: //  E L L I P S E
              
                g.setStroke(new BasicStroke(pp.strokesize)); 
                if(pp.dashed==true)
			  	{
			  		dashed = new BasicStroke(pp.strokesize,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER,10.0f, dash1, 0.0f);
			  		g.setStroke(dashed);
			  	}       
                
                if(pp.filled == true){
                    if(pp.gra==true){
                    	g.setPaint(new GradientPaint(pp.x1, pp.y1, pp.g1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1), pp.g2));
                    }
                    g.fill(new Ellipse2D.Double(pp.x1, pp.y1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1)));
                }
                else
                	g.drawOval(pp.x1, pp.y1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1));
                
                break;

       
                case 2: //  R E C T A N G L E
               
                pp = (Shape)obj2D.elementAt(i);
                g.setColor(pp.col);
                g.setStroke(new BasicStroke(pp.strokesize)); 
                if(pp.dashed==true)
			  	{
			  		dashed = new BasicStroke(pp.strokesize,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER,10.0f, dash1, 0.0f);
			  		g.setStroke(dashed);
			  	}          
                if(pp.rounded == true && pp.filled == true){
                    
                    if(pp.gra==true){
                    	g.setPaint(new GradientPaint(pp.x1, pp.y1, pp.g1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1), pp.g2));
	                   	BufferedImage bi = new BufferedImage(5, 5, BufferedImage.TYPE_INT_RGB);
				        Graphics2D big = bi.createGraphics();
						big.setColor(pp.col);
						big.fillRect(0, 0, 5, 5);
						big.setColor(Color.lightGray);
						big.fillOval(0, 0, 5, 5);
						Rectangle r = new Rectangle(0,0,5,5);
						g.setPaint(new TexturePaint(bi, r));
                    }
                    g.fill(new RoundRectangle2D.Double(pp.x1, pp.y1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1),20,20));
                }

                else if(pp.filled == true){
                	
                    g.setPaint(pp.col);
                    if(pp.gra==true){
                    	g.setPaint(new GradientPaint(pp.x1, pp.y1, pp.g1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1), pp.g2));
                    }
                    g.fill(new Rectangle2D.Double(pp.x1, pp.y1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1)));
                    
                }
                
                else if(pp.rounded == true)
                    g.drawRoundRect(pp.x1, pp.y1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1),20,20);

                else
                    g.drawRect(pp.x1, pp.y1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1));
                    
                break;
				
				
				case 3: //  A R C S
				
				g.setStroke(new BasicStroke(pp.strokesize)); 
				if(pp.dashed==true)
			  	{
			  		dashed = new BasicStroke(pp.strokesize,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER,10.0f, dash1, 0.0f);
			  		g.setStroke(dashed);
			  	}
			  	else if(pp.filled == true){
                	
                    g.setPaint(pp.col);
                    if(pp.gra==true){
                    	g.setPaint(new GradientPaint(pp.x1, pp.y1, pp.g1, Math.abs(pp.x2-pp.x1), Math.abs(pp.y2-pp.y1), pp.g2));
                    }
                    g.fill(new Arc2D.Double(pp.x1, pp.y1, pp.x2-pp.x1,pp.y2-pp.y1,30,190,Arc2D.OPEN));
                    
                }  
                else     
					g.drawArc(pp.x1, pp.y1, pp.x2-pp.x1,pp.y2-pp.y1,30,190);
				
			    break;
					
                case 4: //  L I N E S  A N D  F R E E H A N D
                case 5:
                
                //g.setColor(pp.col);
                g.setStroke(new BasicStroke(pp.strokesize));
                if(pp.dashed==true)
			  	{
			  		dashed = new BasicStroke(pp.strokesize,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER,10.0f, dash1, 0.0f);
			  		g.setStroke(dashed);
			  	}       
                g.drawLine(pp.x1, pp.y1, pp.x2, pp.y2);
               
                break;
                
                case 6: //   T E X T
                
                g.setColor(pp.col);
                istr++;
                //if(istr>2)
                {
                	g.setFont(new Font(pp.ftyp,5,pp.fsiz));
	            	g.drawString(pp.buf,pp.x1,pp.y1);
	         	}
	     
	            break; 
	            
	            case 7:   ImageIcon ic = new ImageIcon(pp.im);
						  
					      Image xx = ic.getImage();
					      g.drawImage(xx, pp.x1, pp.y1, this); 
					    
					      break;     
                

                default: break;


            }// Switch Ends
        g.setComposite(init);    
        g.setTransform(prevTrans);


        }//for Ends
      
      
      if(transparent == 1)
	  {
			AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER,0.5f);
	  	    g.setComposite(ac);
	  }
	  if(showImg == true)
	  {
		 
		 
		  ImageIcon ic = new ImageIcon(picImg);
		  
	      Image imxx = ic.getImage();
	      int impx2 = imxx.getWidth(this); 
	      int impy2 = imxx.getHeight(this);
	      g.drawImage(imxx, imposx, imposy, this);
	      this.validate();
	      obj2D.addElement(new Shape(imposx,imposy, imposx+impx2, imposy+impy2, "Image",picImg));
	      showImg=false;
	      if(transparent == 1)
	  	  {
				((Shape)obj2D.elementAt(obj2D.size()-1)).transp = 1;
		  }
	      repaint();
	  }
	  		
	  g.setColor(getForeground());		
	  // THIS PORTION DRAWS WHEN MOUSE_DRAGGED IS ACTIVE  
      if(motion == false) 
      {
      
      	//Image myImage = Toolkit.getDefaultToolkit().getImage("jicon");
      	//g.drawImage(myImage, 0, 0, this);
      	stroke = new BasicStroke(strokew);
      	g.setStroke(stroke);
      	if(strokestr=="dashed")
	  	{
	  		dashed = new BasicStroke(strokew,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER,10.0f, dash1, 0.0f);
	  		g.setStroke(dashed);
	  	}

        if (mode == LINES) {
            g.setColor(getForeground());
            if (x2 != -1) {
                g.drawLine(x1, y1, x2, y2);
            }
        }
        
        else if (mode == TEXT){
        	
            g.setColor(getForeground());
            
            g.setFont(new Font(font,5,fontsiz));
            if(back==false)
            {
            	tbuf.append(keystroke);
            }
            else
            {
            	g.setColor(getBackground());
            	g.drawString(tbuf.toString(),keyx,keyy);
            	g.drawString(tbuf.toString(),keyx,keyy);
            	tbuf.deleteCharAt(tbuf.length()-1);
            	back=false;
            	return;
            }
            buf=tbuf.toString();
            g.setColor(getBackground());
            g.drawString(tbuf.toString(),keyx,keyy);
            g.setColor(getForeground());
            g.drawString(tbuf.toString(),keyx,keyy);
            back=false;
            obj2D.add(obj2D.size()-1,new Shape(keyx,keyy,buf,fontsiz,font,"Text",getForeground()));
            
        }

        else if (mode == RECT) {
            g.setColor(getForeground());
            if (x2 != -1) {
                    
                   
                    if(round==true && fill==true){
                        g.setPaint(getForeground());
                        if(gra==true){
                    		g.setPaint(new GradientPaint(x1, y1, grad1, Math.abs(x2-x1), Math.abs(y2-y1), grad2));
                    	}
                        g.fill(new RoundRectangle2D.Double(x1, y1, Math.abs(x2-x1), Math.abs(y2-y1),20,20));
                        
                    }
                    else if(fill==true){
                        g.setPaint(getForeground());
                        if(gra==true){
                    		g.setPaint(new GradientPaint(x1, y1, grad1, Math.abs(x2-x1), Math.abs(y2-y1), grad2));
                    	}
                        g.fill(new Rectangle2D.Double(x1, y1, Math.abs(x2-x1), Math.abs(y2-y1)));
                    }
                    else if(round==true)
                        g.drawRoundRect(x1, y1, Math.abs(x2-x1), Math.abs(y2-y1),20,20);

                    else
                        g.drawRect(x1, y1, Math.abs(x2-x1), Math.abs(y2-y1));
                        //g.fill3DRect(x1, y1, Math.abs(x2-x1)-20, Math.abs(y2-y1)-20,true);
                    
            }
        }
        
        else if (mode == LINES) {
            g.setColor(getForeground());
            if (x2 != -1) {
                g.drawLine(x1, y1, x2, y2);
            }
        }
        
        else if (mode == ARC) {
            g.setColor(getForeground());
            if (x2 != -1) {
            	if(fill==true){
                        g.setPaint(getForeground());
                        if(gra==true){
                    		g.setPaint(new GradientPaint(x1, y1, grad1, Math.abs(x2-x1), Math.abs(y2-y1), grad2));
                    	}
                        g.fill(new Arc2D.Double(x1, y1, x2-x1,y2-y1,30,190,Arc2D.OPEN));

                }
                else
                {
                	g.drawArc(x1, y1, x2-x1, y2-y1,30,190);
                }
                
            }
        }

        else if (mode == ELLIPSE) {
            g.setColor(getForeground());
            if (x2 != -1) {
                
                if(fill==true){
                        g.setPaint(getForeground());
                        if(gra==true){
                    		g.setPaint(new GradientPaint(x1, y1, grad1, Math.abs(x2-x1), Math.abs(y2-y1), grad2));
                    	}
                        g.fill(new Ellipse2D.Double(x1, y1, Math.abs(x2-x1), Math.abs(y2-y1)));

                }
                else
                {
                	g.drawOval(x1, y1, Math.abs(x2-x1), Math.abs(y2-y1));
                }

            }
        }
        
           
      }// if (motion==false) ends
    
      else if(motion==true && index !=-1)
      {
	      	Color CC = getForeground();
	      	g.setColor(Color.black);
	      	g.fill(new Rectangle2D.Double(r.x1,r.y1,10,10));
	      	g.fill(new Rectangle2D.Double(r.x2-10,r.y2-10,10,10));
	      	g.setColor(CC);
	      	//g.drawRect(r.x1,r.y1,10,10);
	      	//g.drawRect(r.x2-10,r.y2-10,10,10);
      }
      g.setComposite(init);
 
    }
    
    
    //    C O N S T R U C T O R     //
    
    public DrawCanvas() {
    
        setBackground(Color.white);
        setForeground(Color.gray);
        
        setLayout(new BorderLayout(0,0));

        //DrawCanvas drawingCanvas = new DrawCanvas();
              
        Scrollbar hbar = new Scrollbar(Scrollbar.HORIZONTAL);    
        Scrollbar vbar = new Scrollbar(Scrollbar.VERTICAL);    
        //add("Center", drawingCanvas); 
        //add("East",vbar);
        //add("South",hbar);
        
        addMouseMotionListener(this);
        addMouseListener(this);
        addKeyListener(this);
        //ScrollPane sp = new ScrollPane(1);
        //this.add(sp);
        init = AlphaComposite.getInstance(AlphaComposite.SRC_OVER,1.0f);       
          
          popup.add("Bring to Front");
          popup.add("Delete");
          popup.addSeparator();
          popup.add("Cut");
          popup.add("Copy");
          popup.add("Paste");
          popup.addSeparator();
          popup.add("Clear");
          cmi.addActionListener(this);
          popup.add(cmi);
          //popup.addSeparator();
          //popup.add("Undo");
          //popup.add("Exit");
          add(popup);
          popup.addActionListener(this);
    }


    public void actionPerformed(ActionEvent e) {

          String command = e.getActionCommand();
          doPopupMenuCommand(command);
    }


    void doPopupMenuCommand(String command) {
         // Handle a command from the pop-up menu.
           
     
      if (command.equals("Red"))
         setForeground(Color.red);
      else if (command.equals("Text"))
         setDrawMode(TEXT);
      else if (command.equals("Clear"))
         clear=true;
      else if (command.equals("Copy"))
      {
            if(r!=null)
            {
            	//p = r;
            	pdash = new Shape();
            	r.setToSame(pdash);
            	System.out.println(pdash.type);
            
            }
      }
      else if (command.equals("Cut"))
      {
            if(r!=null)
            {
            	//p = r;
            	pdash = new Shape();
            	r.setToSame(pdash);
            	System.out.println(pdash.type);
            	obj2D.removeElementAt(index);
            
            }
      }
      else if (command.equals("Delete"))
      {
            if(r!=null)
            {
            
            	obj2D.removeElementAt(index);
         
            }
      }
      else if (command.equals("Paste"))
      {
            
            p=new Shape();
            //p=pdash.clone();
            pdash.setToSame(p);
            //p.col=Color.red;
           
        	int popx1=p.x1;
        	int popy1=p.y1;
        	int popx2=p.x2;
        	int popy2=p.y2;
        	p.x1=x;
        	p.y1=y;
        	p.x2=x+popx2-popx1;
        	p.y2=y+popy2-popy1;
        	obj2D.addElement((Shape)p);
      
      }
      
      else if (command.equals("Bring to Front"))
      {
      	 	pdash = new Shape();
            r.setToSame(pdash);
      	 	obj2D.removeElementAt(index);
      	 	p=new Shape();
            pdash.setToSame(p);
      	 	obj2D.addElement((Shape)p);
      }
      
      else if (command.equals("Move"))
      {
            if(this.motion==false)
                this.motion=true;
            else if(this.motion==true)
                this.motion=false;
      }
      
      else if (command.equals("Undo"))
      {
         int count =2;
         obj2D.remove(obj2D.size()-2);
         if(obj2D.size()==0)
         	count=2;
         else count++; 
         System.out.println("Undone");
         repaint();
      }
      else if (command.equals("Bring To Front")) {
         obj2D.remove(index);
         obj2D.addElement(r);
      }
      else if (command.equals("Exit"))
        System.exit(0);
      repaint();
   }



	


    public void checkSwap()
    {
            int t;
            if(x2<x1)  // x1,x2 -> 5,10
            {
                t=x2; //t=10
                x2=x1; //x2=5
                x1=t;  //x1=10
            }
            if(y2<y1)
            {
                t=y2;
                y2=y1;
                y1=t;
            }
    }
    
    
       


}
	